<template>
  <div style="margin: 7rem 4rem" class="confirmedContract">
    <header>
       <ReturnButton style="z-index: 234232" :offsetArrow="20" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage('confirmado')"> </ReturnButton>
       <!-- BOTON DE ADENDA SI ES CONTRATO ORIGINAL  -->
       <el-row style="margin-top: 3rem" v-if="showContract.stateContrato === 'CONTRATO ORIGINAL'">
         <el-col :span="3" :offset="20"> 
           <el-button  @click="enterAddendum('adenda', showContract)" justify="end" type="primary" :disabled="stateContract === 'pendiente' || stateContract==='cancelado' || stateContract === 'prueba'">+ ADENDA</el-button>
          </el-col>
       </el-row>
       <!-- BOTON DE ADENDA E HISTORIAL SI YA TIENE ADENDA  -->
       <el-row style="margin-top: 3rem" v-else>
          <el-col :span="3" :offset="16"> 
            <el-button :disabled="stateContract === 'prueba' || stateContract === 'pendiente' || showContract.disableHistory == true"  @click="changeContract('historial', showContract.contractHistory )" justify="end"  icon="el-icon-time" type="primary" plain> HISTORIAL</el-button>
          </el-col>
         <el-col :span="3" :offset="1"> 
            <el-button :disabled="stateContract === 'prueba' || stateContract === 'pendiente'" @click="enterAddendum('adenda', showContract)" justify="end" type="primary" >+ ADENDA</el-button>
          </el-col>
       </el-row>
    </header>
    <section>
      <div style="margin: 2rem 4rem"  v-if="showContract.stateContrato === 'CONTRATO ORIGINAL'">
        <el-row  type="flex" justify="end" style="margin: 1rem 0px 1.5rem 0px">
          <!-- boton de editar BTN PENDIENTE -->
          <el-col :span="4" v-if="stateContract == 'pendiente'" style="padding-left: 2.7rem">
            <el-button   class="btnEditStyle" icon="el-icon-edit" @click="enterAddendum('pendiente', showContract)"><strong>EDITAR</strong></el-button>
          </el-col>
        </el-row>
         <el-row :gutter="24" v-bind:class="[stateContract === 'pendiente' ? 'bg-gray' : 'bgdContractPending' ]">
          <!-- TITULO -->
          <el-col :span="10">
            <el-card shadow="never" class="bg-gray border-none" style="font-size:20px; font-weight:700" v-if="stateContract === 'pendiente'">
              <span  style="color:red">CONTRATO PENDIENTE 
                <span style="padding-left: 15px; color: #818181 "> (Cod Reg. {{ showContract.contractCode}} )</span>
              </span>
            </el-card>

            <el-card shadow="never" class="border-none styleTitleGeneral" v-else>
              <span>CONTRATO <span style="padding-left: 15px"> (Cod Reg. {{ showContract.contractCode}} )</span></span>
            </el-card>
          </el-col>
        </el-row>
      </div>
      <!-- TITULO DE LA PRIMERA ADENDA DEL CONTRATO -->
      <div style="margin: 2rem 4rem" v-else>
        <el-row  type="flex" justify="end" style="margin: 1rem 0px 1.5rem 0px">
          <!-- boton de editar BTN PENDIENTE -->
          <el-col :span="4" v-if="stateContract == 'pendiente'" style="padding-left: 2.7rem">
            <el-button   class="btnEditStyle" icon="el-icon-edit" @click="enterAddendum('pendiente', showContract)"><strong>EDITAR</strong></el-button>
          </el-col>
        </el-row>
        <el-row :gutter="24" class="bg-gray">
          <el-card shadow="never" class="bg-gray border-none title-views" style="color: red" v-if="stateContract == 'pendiente'">{{   showContract.stateContrato }} DEL CONTRATO - PENDIENTE<span style="padding-left: 15px; color:#818181"> (Cod Reg. {{ showContract.contractCode}} )</span></el-card>
          <el-card shadow="never" class="border-none styleTitleGeneral" v-else>{{ showContract.stateContrato }} DEL CONTRATO <span style="padding-left: 15px"> (Cod Reg. {{ showContract.contractCode}} )</span></el-card>
        </el-row>
      </div>
      
      <!-- INFORMACION DE LA PRIMERA ADENDA -->
      <div style="margin:4rem 4rem 1rem 4rem" v-if="showContract.stateContrato !== 'CONTRATO ORIGINAL'">
        <el-row>
          <el-col :span="5" :offset="7"> <h3 class="text-orange" style="margin-bottom:1.5rem"> FECHA DE LA ADENDA </h3> </el-col>
        </el-row>
        <el-row :gutter="10">
          <el-col :span="4" :offset="3" ><div class="grid-content" style="margin-top:2rem">
            <img src="../../assets/images/calendar.svg" alt="">
          </div> 
        </el-col>
         <el-col :span="17" class="box-historial title-views line-heigth" style="padding: 3rem 4rem; font-size:16px">
    
           <div class="grid-content">
             <el-row>
                <el-col :span="7"> Fecha de Registro: </el-col>
                <el-col class="font-general" :span="7"> {{ addendumRegistrationDate }}  </el-col>
              </el-row>
           </div> 
           <div class="grid-content">
              <el-row>
                <el-col :span="7">Fecha de Adenda:</el-col>
                <el-col class="font-general" :span="7">{{ dateOfAddendumValue }} </el-col>
              </el-row>
           </div>    
          </el-col>
        </el-row> 
      </div>

      <!-- DATOS DEL CONTRATO -->
      <div style="margin:4rem">
        <el-row>
          <el-col :span="5" :offset="7"> <h3 class="text-orange" style="margin-bottom:1.5rem"> DATOS DEL CONTRATO </h3> </el-col>
        </el-row>
        <el-row>
          <el-col :span="4" :offset="3" style="margin-top: 9rem"><div class="grid-content"> <img src="../../assets/images/datos.svg" alt="">  </div> 
         </el-col>
          <el-col :span="17" class="box-historial title-views line-heigth" style="padding: 3rem 4rem; font-size:16px;">
            <div class="grid-content">
              <el-row>
                <el-col :span="7"> Proveedor: </el-col>
                <el-col class="font-general" :span="15">  {{showContract.contractName || 'No ingresado'}} </el-col>
              </el-row>
           </div> 
            <div class="grid-content">
              <el-row>
                <el-col :span="7"> Cod Proveedor: </el-col>
                <el-col class="font-general" :span="7"> {{ showContract.providerCode || 'No ingresado' }}  </el-col>
              </el-row>
            </div> 
           <div class="grid-content">
              <el-row>
                <el-col :span="7"> Tipo de Proveedor: </el-col>
                <el-col class="font-general" :span="7">  {{ showContract.providerType || 'No ingresado'}}   </el-col>
              </el-row>
           </div>
           <div class="grid-content">
              <el-row>
                <el-col :span="7"> Tipo de Contrato: </el-col>
                <el-col class="font-general" :span="7">  {{ showContract.typeContract || 'No ingresado'}}   </el-col>
              </el-row>
           </div>

           <div class="grid-content">
              <el-row>
                <el-col :span="7"> N° Contr. Distribuidor: </el-col>
                <el-col class="font-general" :span="7">  {{ showContract.contratoDistribuidor || 'No ingresado'}}   </el-col>
              </el-row>
           </div>

    
           <el-row>
             <el-col :span="11">
               <div>
                  <h3 class="text-orange" style="margin:1.5rem 0"> Fecha del Contrato </h3>
               </div>
                <div class="grid-content">
                  <el-row>
                    <el-col :span="11" > Fecha de Registro:  </el-col>
                    <el-col :offset="1" class="font-general" :span="7"> {{ showContract.registrationDate}} </el-col>
                  </el-row>
                </div> 
                <div class="grid-content">
                  <el-row>
                    <el-col :span="12">  Fecha de Contrato:  </el-col>
                    <el-col class="font-general" :span="7">  {{ showContract.contractDate}}  </el-col>
                  </el-row>
                </div> 
             </el-col>
             <el-col :span="1">
               <hr style="height 30px; height: 100px; margin-top: 30px" class="hr-vertical-orange">
             </el-col>
                    
             <el-col :span="11" style="margin-left:20px">           
                <div>
                  <h3 class="text-orange" style="margin:1.5rem 0"> Vigencia del Contrato : </h3>
                </div>
                  <div class="grid-content">
                    <el-row>
                      <el-col :span="11"> Inicio de Vigencia: </el-col>
                      <el-col :offset="1" class="font-general" :span="7">{{ showContract.validityString[0].startValidity }} </el-col>
                    </el-row>
                  </div> 
                  <div class="grid-content">
                    <el-row>
                      <el-col :span="11">  Fin de Vigencia: </el-col>
                      <el-col :offset="1" class="font-general" :span="7"> {{ showContract.validityString[0].endValidity }} </el-col>
                    </el-row>
                </div>  
               </el-col>
             </el-row>    
          </el-col>
        </el-row> 
      </div>

       <!-- IMPORTE DEL CONTRATO -->
      <div style="margin:4rem 4rem 1rem 4rem" v-if="showContract.typeContract !== 'Afiliación'">
        <el-row>
          <el-col :span="5" :offset="7"> <h3 class="text-orange" style="margin-bottom:1.5rem"> IMPORTE DEL CONTRATO </h3> </el-col>
        </el-row>
        <el-row :gutter="10">
          <el-col :span="4" :offset="3" ><div class="grid-content" style="margin-top:4rem">
            <img src="../../assets/images/importe.svg" alt="">
          </div> 
        </el-col>
         <el-col :span="17" class="box-historial title-views line-heigth" style="padding: 3rem 4rem; font-size:16px">
            <div>
              <h3 v-if="showContract.proratedCheck" class="text-orange" > Prorrateado </h3>
              <h3 v-else class="text-orange" > No Prorrateado </h3>             
           </div>
           <div class="grid-content" style="margin-top:1rem">
             <el-row>
                <el-col :span="7"> Moneda: </el-col>
                <el-col class="font-general" :span="7"> {{ moneyValue }}</el-col>
              </el-row>
           </div> 
           <div class="grid-content">
              <el-row>
                <el-col :span="7">Total de Materiales:</el-col>
                <el-col class="font-general" :span="7"> {{ totalMaterials }}  </el-col>
              </el-row>
           </div>
           <div class="grid-content" v-show="providerType">
              <el-row>
                <el-col :span="7">Total de Impuestos:</el-col>
                <el-col class="font-general" :span="7">{{ totalPercent }}  </el-col>
              </el-row>
           </div> 
           <div class="grid-content">
              <el-row>
                <el-col :span="7"> Importe Total: </el-col>
                <el-col class="font-general" :span="7"> {{ totalMaterialValue }} </el-col>
              </el-row>
           </div>     
          </el-col>
        </el-row> 
      </div>
        <!-- CUOTAS DEL CONTRATO -->
      <div style="margin:4rem" v-if="showContract.typeContract !== 'Afiliación'">
        <el-row>
          <el-col :span="5" :offset="7"> <h3 class="text-orange" style="margin-bottom:1.5rem"> CUOTAS DEL CONTRATO </h3> </el-col>         
        </el-row>
        <el-row>
          <el-col :span="4" :offset="3" style="padding-top:5rem">
            <div class="grid-content">
              <img src="../../assets/images/cuotas.svg" alt="">
            </div> 
         </el-col>
          <el-col :span="17" class="box-historial title-views line-heigth" style="padding: 3rem 4rem; font-size:16px">
           <p style="margin-bottom:2rem">N° de Cuotas: <span style="font-weight:400; padding-left:2rem;"> {{ showContract.contractFees.length}} </span> </p>
              <el-table 
                :header-cell-class-name="tableRowClassName2"
                border
                :data="showContract.contractFees">
                <el-table-column
                  prop="id"
                  label="Cuota"
                  width="100">
                </el-table-column>
                <el-table-column
                  label="Fecha de Vencimiento"
                  width="180">
                  <template slot-scope="scope">
                    <P> {{ ordenandoFormatoFecha(scope.row.dueDate)  }} </P>
                  </template>
                </el-table-column>
                <el-table-column 
                  prop=""
                  label="N° de Factura"
                  width="140">
                </el-table-column>
                  <el-table-column
                  prop=""
                  label="Fecha de Pago"
                  width="140">
                </el-table-column>
                  <el-table-column 
                  prop="amount" 
                  label="Importe">
                </el-table-column>       
              </el-table>
              <!-- <hr class= "line-card"> -->
              <el-row style="margin:2rem 0 1rem">
                <el-col :span="7" :offset="16" class="text-orange"> <p style="text-align: right;"> Total: <span> <span style="padding-left:1rem"> {{ showContract.currencySymbol}} </span> {{ totalAmount }} </span></p></el-col>
              </el-row>
          </el-col>
        </el-row> 
      </div>
      <!-- AMORTIZACIÓN -->
      <div style="margin:4rem">
        <el-row>
          <el-col :span="15" :offset="7"> <h3 class="text-orange" style="margin-bottom:1.5rem"> CANAL DE AMORTIZACIÓN: </h3> </el-col>
        </el-row>
        <el-row :gutter="10">
          <el-col :span="4" :offset="3" ><div class="grid-content" style="margin-top:2rem">
              <img src="../../assets/images/senal.svg" alt="">
            </div> 
          </el-col>
         <el-col :span="17" class="box-historial title-views line-heigth" style="padding: 3rem 4rem; font-size:16px">  
           <div class="grid-content">
              <el-row>
                <el-col class="font-general" :span="7">  {{showContract.typeAmortization}} </el-col>
              </el-row>
           </div>
          </el-col> 
        </el-row>
      </div>
    </section>
    <main>
      <div style="margin: 4rem 8rem" >
        <h3 class="text-orange" > MATERIALES DEL CONTRATO</h3> 
        <!-- <p style="margin-top:4rem" >Total de Materiales:  <span style="margin-left:2rem"> {{ showContract.refMaterials.length }} </span></p> -->
     </div>
      <div style="margin: 4rem 8rem" v-if="americaTv.length > 0">
        <p class="box-gray" style="margin-top:4rem" ><strong>AMERICA TV <span style="margin-left:2rem"> Total de Materiales: {{ counterAmericaTv }} </span> </strong></p>
      </div>
      
      <!-- TABLA  -->
      <div style="margin: 1rem 4rem" v-if="americaTv.length > 0">
        <el-table      
            :header-cell-class-name="tableRowClassNameMaterialsContract"
            :data="americaTv"
            :row-class-name="tableRowClassNameSpace"
            :row-style="toggleDisplayTr"
            border stripe
            class="init_table"
            style="width: 100%">
          <el-table-column
            width="180px"
            fixed
            label="TÍTULO"
            show-overflow-tooltip
            align="left">
              <template slot-scope="scope">
                <p :class="classOrange(scope.row)"  class="text-start text-ellipsis" :style="`color: #544e4e!important; margin-left: ${scope.row.__level * 20}px;margin-top:0;margin-bottom:0;font-weight: bold`">
                  <i  @click="toggleFoldingStatus(scope.row)" style="padding: 5px;font-weight:bold;font-size: 18px;" class="permission_toggleFold text-orange" :class="toggleFoldingClass(scope.row)">
                  </i>{{scope.row.Name}}</p>
              </template>
          </el-table-column>
          <el-table-column
            label="FECHA DE LLEGADA" width="180px">
            <template slot-scope="scope">
              <div v-if="scope.row.arrivalDate">
                  <p>{{ new Date(scope.row.arrivalDate).toLocaleDateString('en-GB') }}</p>
              </div>
            </template> 
          </el-table-column>
          <el-table-column
            prop="typeOfContent"
            label="CENTRO DE COSTO" width="180px">
          </el-table-column>
          <el-table-column
            label="PRECIO UNITARIO" width="180px">
            <template slot-scope="scope">
              <p> {{scope.row.unitPrice }}</p>
            </template>
          </el-table-column>
           <!-- v-if="showContract.typeContract !== 'Afiliación'" -->
          <el-table-column
            prop="totalPass"
            label="NÚMERO DE PASADAS" width="110px">
          </el-table-column>
          <el-table-column
            prop="pasadasConsumidas"
            label="PASADAS CONSUMIDAS" width="110px">
          </el-table-column>
          <el-table-column
            prop="saldoPasadas"
            label="SALDO DE PASADAS" width="90px">
          </el-table-column>
          
           <el-table-column
            label="EMISIONES">
             <el-table-column width="150px">
                <template slot-scope="scope">
                  <div v-for="(validate, index) in scope.row.emissions"
                    :key="index">
                    <p class="font-weight-min" v-if="( validate !== 'No emitido')"> {{ new Date(validate).toLocaleDateString('en-GB') }} </p>
                  </div>
                </template>
              </el-table-column>
          </el-table-column>

          <el-table-column label="VIGENCIA">
              <el-table-column width="50px">
                <template slot-scope="scope">
                  <div v-for="(validate, index) in scope.row.validityString"
                    :key="index" :class="classCellTable(index, scope.row.validityString)">
                    <p class="font-weight-min">{{index+1}}.</p>
                  </div>
                </template>
              </el-table-column>
              <el-table-column label="INICIO" width="120px">
                <template slot-scope="scope">
                  <div v-for="(validate, index) in scope.row.validityString"
                  :key="index" :class="classCellTable(index, scope.row.validityString)">
                    <p class="font-weight-min" v-if="typeof(validate.startValidity) == 'string'">{{ validate.startValidity }}</p>
                    <p class="font-weight-min" v-else>{{ new Date(validate.startValidity).toLocaleDateString('en-GB') }}</p>
                  </div>
                </template>
              </el-table-column>
              <el-table-column label="FIN" width="120px">
                <template slot-scope="scope">
                  <div v-for="(val, index) in scope.row.validityString"
                    :key="index" :class="classCellTable(index, scope.row.validityString)">
                    <p class="font-weight-min" v-if="typeof(val.endValidity) == 'string'">{{ val.endValidity }}</p>
                    <p class="font-weight-min" v-else> {{ new Date(val.endValidity).toLocaleDateString('en-GB') }}</p>
                  </div>
                </template> 
              </el-table-column>
              <el-table-column label="VENTANA" width="120px">
                  <template slot-scope="scope">
                    <div v-for="(valid, index) in scope.row.validityString"
                      :key="index" :class="classCellTable(index, scope.row.validityString)">
                      <p v-if="valid.startWindow !== undefined" class="font-weight-min f-size-13"> {{ new Date(valid.startWindow).toLocaleDateString('en-GB') }}</p>
                      <p v-else style="height: 15px"> </p>    
                      <p v-if="valid.endWindow !== undefined" class="font-weight-min f-size-13"> {{ new Date(valid.endWindow).toLocaleDateString('en-GB') }} </p>                       
                      <p v-else style="height: 15px"> </p>                       
                    </div>
                  </template>   
              </el-table-column>
          </el-table-column>   
        </el-table>    
      </div>

      <div style="margin: 4rem 8rem" v-if="americaNext.length > 0">
        <p class="box-gray" style="margin-top:4rem" > <strong>AMERICA NEXT  <span style="margin-left:2rem"> Total de Materiales: {{ counterAmericaNext }} </span> </strong></p>
      </div>

      <div style="margin: 1rem 4rem" v-if="americaNext.length > 0">
        <el-table      
            :header-cell-class-name="tableRowClassNameMaterialsContract"
            :data="americaNext"
            :row-class-name="tableRowClassNameSpace"
            :row-style="toggleDisplayTr"
            border stripe
            class="init_table"
            style="width: 100%">
          <el-table-column
            width="180px"
            fixed
            label="TÍTULO"
            show-overflow-tooltip
            align="left">
              <template slot-scope="scope">
                <p :class="classOrange(scope.row)"  class="text-dark-gray-1 text-start text-ellipsis" :style="`margin-left: ${scope.row.__level * 20}px;margin-top:0;margin-bottom:0;font-weight: bold`">
                  <i  @click="toggleFoldingStatus(scope.row)" style="padding: 5px;font-weight:bold;font-size: 18px;" class="permission_toggleFold text-orange" :class="toggleFoldingClass(scope.row)">
                  </i>{{scope.row.Name}}</p>
              </template>
          </el-table-column>
          <el-table-column
            label="FECHA DE LLEGADA" width="180px">
            <template slot-scope="scope">
              <div v-if="scope.row.updateDate">
                  <p>{{ new Date(scope.row.updateDate).toLocaleDateString('en-GB') }}</p>
              </div>
            </template> 
          </el-table-column>
          <el-table-column
            prop="typeOfContent"
            label="CENTRO DE COSTO" width="180px">
          </el-table-column>
          <el-table-column
            label="PRECIO UNITARIO" width="180px"> 
            <template slot-scope="scope">
              <p>{{scope.row.unitPrice }}</p>
            </template>
          </el-table-column>
           <!-- v-if="showContract.typeContract !== 'Afiliación'" -->
          <el-table-column
            prop="totalPass"
            label="NÚMERO DE PASADAS" width="110px">
          </el-table-column>
          <el-table-column
            prop="pasadasConsumidas"
            label="PASADAS CONSUMIDAS" width="110px">
          </el-table-column>
  
          <el-table-column
            prop="saldoPasadas"
            label="SALDO DE PASADAS" width="90px">
          </el-table-column>
          <el-table-column
            prop="totalPass"
            label="EMISIONES" width="90px">
          </el-table-column>
          <el-table-column label="VIGENCIA" >
              <el-table-column width="50px">
                <template slot-scope="scope">
                  <div v-for="(validate, index) in scope.row.validityString"
                    :key="index" :class="classCellTable(index, scope.row.validityString)">
                    <p class="font-weight-min">{{index+1}}.</p>
                  </div>
                </template>
              </el-table-column>
              <el-table-column label="INICIO" width="120px">
                <template slot-scope="scope" >
                    <div v-for="(validate, index) in scope.row.validityString"
                    :key="index" :class="classCellTable(index, scope.row.validityString)">
                      <p class="font-weight-min" v-if="typeof(validate.startValidity) == 'string'">{{ validate.startValidity }}</p>
                      <p class="font-weight-min" v-else>{{ new Date(validate.startValidity).toLocaleDateString('en-GB') }}</p>
                    </div>
                </template> 
              </el-table-column>
              
              <el-table-column label="FIN" width="120px">
                  <template slot-scope="scope">
                    <div v-for="(val, index) in scope.row.validityString"
                    :key="index" :class="classCellTable(index, scope.row.validityString)">
                      <p class="font-weight-min" v-if="typeof(val.endValidity) == 'string'">{{ val.endValidity }}</p>
                      <p class="font-weight-min" v-else> {{ new Date(val.endValidity).toLocaleDateString('en-GB') }}</p>
                    </div>
                  </template> 
              </el-table-column>

              <el-table-column label="VENTANA" width="120px">   
                  <template slot-scope="scope">
                    <div v-for="(valid, index) in scope.row.validityString"
                      :key="index" :class="classCellTable(index, scope.row.validityString)">
                      <p v-if="valid.startWindow !== undefined" class="font-weight-min f-size-13"> {{ new Date(valid.startWindow).toLocaleDateString('en-GB') }}</p>
                      <p v-else style="height: 15px"> </p>    
                      <p v-if="valid.endWindow !== undefined" class="font-weight-min f-size-13"> {{ new Date(valid.endWindow).toLocaleDateString('en-GB') }} </p>                       
                      <p v-else style="height: 15px"> </p>                       
                    </div>
                  </template>   
              </el-table-column>
          </el-table-column>   
        </el-table>    
      </div>

    </main>
  </div>
  
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import Vue from 'vue'
import { mapState } from 'vuex'
  /**
  * @vue-data {String} statehistory - Validacion si ya tiene mas de una adenda
  * @vue-data {Object} showContract - Datos del contrato actual, sea adenda u original
  * @vue-computed {Number} totalAmount - Cantidad total del contrato
  */
export default {
  
  components: {
      ReturnButton,
  },
  data () {
    return {
      // showContract: JSON.parse(this.$localStorage.get("aceptContract")),
      // stateContract: JSON.parse(this.$localStorage.get("state")),
      statehistory: JSON.parse(this.$localStorage.get("stateH")),
      // stateContract: this.$storestate.contractStatus,
      showContract: this.$store.state.setInContract,
      tableListData: [],  
      foldList: [],
      dataJs: [],
      prueba: [],
      americaTv: [], 
      americaNext: []
    }
  },
  created() {
    this.refMaterialPriceAmort()
    this.prueba = this.formatConversion([], this.dataJs)
  },
  computed: {
    ...mapState({
      stateContract: state => state.contractStatus
    }),
    totalAmount() {
      let count = 0;
      this.showContract.contractFees.map((el, i, arr) => {
        let number = Number(el.amount)
        count += number
      })
      return count
    },
    counterAmericaTv() {
      let conditional = this.americaTv.filter(el => el.__level == 0)
      let value = String(conditional.length)
      return value >= 10 ? value  : '0' + value
    },
    counterAmericaNext() {
      let conditional = this.americaNext.filter(el => el.__level == 0)
      let value = String(conditional.length)
      return value >= 10 ? value  : '0' + value
    },
    dateOfAddendumValue() {
      return this.showContract.validityString[0].dateOfAddendum == 'Invalid Date' ? 'No ingresado' : this.showContract.validityString[0].dateOfAddendum
    },
    addendumRegistrationDate() {
      return this.showContract.validityString[0].addendumRegistrationDate == 'Invalid Date' ? 'No ingresado' : this.showContract.validityString[0].addendumRegistrationDate
    },
    totalMaterialValue() {
      return this.showContract.totalAmount == '' || this.showContract.currencySymbol == null ? 'No ingresado' : this.showContract.currencySymbol + ' - ' + this.showContract.totalAmount
    },
    totalMaterials() {
      return this.showContract.totalMaterials == '' || this.showContract.currencySymbol == null ? 'No ingresado' : this.showContract.currencySymbol + ' - ' + this.showContract.totalMaterials
    },
    totalPercent() {
      return this.showContract.percent == '' || this.showContract.percentage == '' || this.showContract.currencySymbol == null ? 'No ingresado' : `(${this.showContract.percent}) ` + this.showContract.currencySymbol + ' ' + this.showContract.percentage
    },
    moneyValue() {
      // console.log(this.showContract.typeCurrency, 'this.showContract.typeCurrency')
      // console.log(this.showContract.currencySymbol, 'this.showContract.currencySymbol')
      // console.log('____________moneyValue____________')
      return this.showContract.currencySymbol == null || this.showContract.typeCurrency == null ? 'No ingresado' : this.showContract.currencySymbol + ' - ' + this.showContract.typeCurrency
    },
    providerType() {
      return this.showContract.providerType == 'Local' ? true : false
    }
  },
  methods: {
    ordenandoFormatoFecha ( dateString ) {
      console.log(dateString, 'dateString')
      let data = dateString.split('-')
      let newd = data[2] + '/' + data[1] + '/' + data[0]
      return newd

    },
    toggleDisplayTr ({row, index}) {
      for (let i = 0; i < this.foldList.length; i++) {
        let item = this.foldList[i]
        if (row.__family.includes(item) && row.__identity !== item) return 'display:none;'
      }
      return ''
    },
     toggleFoldingStatus (params) {
      this.foldList.includes(params.__identity) ? this.foldList.splice(this.foldList.indexOf(params.__identity), 1) : this.foldList.push(params.__identity)
    },
    classOrange(params) {
      let clase;
      params.Children.map((el, i, arr) => {
        if( el.__level !== 1 ) {
          clase = 'text-orange'
           return clase
        }
      }) 
      return clase
    },
    toggleFoldingClass (params) {   
      return params.Children.length === 0 ? 'permission_placeholder' : (this.foldList.indexOf(params.__identity) === -1 ? 'el-icon-arrow-down' : 'el-icon-arrow-right')
    },
    formatConversion (parent, children, index = 0, family = [], elderIdentity = 'x') {
      if (children.length > 0) {
        children.map((x, i) => {
          Vue.set(x, '__level', index)
          Vue.set(x, '__family', [...family, elderIdentity + '_' + i])
          Vue.set(x, '__identity', elderIdentity + '_' + i)
          parent.push(x)
          if (x.Children.length > 0) this.formatConversion(parent, x.Children, index + 1, [...family, elderIdentity + '_' + i], elderIdentity + '_' + i)
        }) 
      } return parent
    },
    /** Trae los datos de los materiales del contrato puestos en refMaterials y addmitedMaterials*/
    refMaterialPriceAmort() {
      let arrayChapter = []
      let type = [];
      let saldo = 0
      let pasadasC = 0
      
      this.showContract.refMaterials.map(( ello, i, arr) => {
        let materials
        this.showContract.admittedMaterials.map((val, key) => {         
          if(ello._id == val._id) {

          const conditionalPrice = val.unitPrice == 'Cortesía' ?  'Material de Cortesía' : val.unitPrice == 0 ? 0 : val.currencySymbol + ' ' + val.unitPrice
            materials = {
              "Name": ello.originalTitle,
              "arrivalDate": ello.arrivalDate || '',
              "emissions": ello.emissions,
              "typeOfContent": ello.typeOfContent,
              "unitPrice": conditionalPrice,
              "spentConsumed": 0,
              "totalPass": ello.totalPass,
              "saldoPasadas": (Number(ello.totalPass) - Number(ello.pasadasConsumidas)),
              "pasadasConsumidas": ello.pasadasConsumidas,
              "balanceToBeAmortized": ello.unitPrice/2,
              "validityString": ello.validity,
              "Children": [],
              "type": (ello.checkedChanels.length == 0)?'América TV':ello.checkedChanels[0],
              "currencySymbol": ello.currencySymbol
            }
            let typeContent = ello.checkedChanels ? ello.checkedChanels[0] : ''
            if(ello.numChapters.length > 0) {
              ello.numChapters.map((el, i,arr) => {
                let temporada = {
                  "Name": 'TEMPORADA ' + el.season,
                  "type": typeContent,
                  "Children": []
                }
                materials.Children.push(temporada)
              })
            }
          }
        })
        
        type.push(ello.typeOfContent)
        this.dataJs.push(materials)
      })

        this.showContract.admittedMaterials.map((el, indice, arr) => {
            el.numChapters.map((element, index, arr) => {
              const array = []
              if ( element.arrOfChapters ) {
                element.arrOfChapters.map((el, i, arr) => {
                  const conditionalPrice = el.unitPrice == 'Cortesía' ?  'Material de Cortesía' : el.unitPrice == 0 ? 0 : el.currencySymbol + ' ' + el.unitPrice
                  let infoSeason = {
                    "Name": "Capitulo " + el.id,
                    "arrivalDate": el.arrivalDate,
                    "typeOfContent": type[indice],
                    "unitPrice": conditionalPrice,
                    "spentConsumed": 0,
                    "totalPass": el.specificPass,
                    "saldoPasadas": this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions ? (Number(el.specificPass) - this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions.length) : Number(el.specificPass),
                    "emissions": this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions ? this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions: "",
                    "pasadasConsumidas": this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions ? this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions.length : 0,
                    "balanceToBeAmortized": "",
                    "Children": [],
                    "validityString": [],
                    "type": (this.showContract.refMaterials[indice].checkedChanels.length == 0)?'América TV':this.showContract.refMaterials[indice].checkedChanels[0]
                  }
                  array.push(infoSeason)
                })
              }
              else {
                element.infoByChapter.map((el, i, arr) => {
                let infoSeason = {
                    "Name": "Capitulo " + el.chapter,
                    "arrivalDate": '',
                    "typeOfContent": type[indice],
                    "unitPrice": '',
                    "spentConsumed": '',
                    "totalPass": '',
                    "saldoPasadas": '',
                    "emissions": this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions ? this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions: "",
                    "pasadasConsumidas": this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions ? this.showContract.refMaterials[indice].numChapters[index].infoByChapter[i].emissions.length : 0,
                    "balanceToBeAmortized": "",
                    "Children": [],
                    "validityString": [],
                    "type": (this.showContract.refMaterials[indice].checkedChanels.length == 0)?'América TV':this.showContract.refMaterials[indice].checkedChanels[0]
                  }
                  array.push(infoSeason)
                })
              }
              
              for (let i = 0; i< element.infoByChapter.length; i++) {
                array[i].validityString =  element.infoByChapter[i].validity
                array[i].arrivalDate =  element.infoByChapter[i].arrivalDate
              }
              this.dataJs[indice].Children[index] ? this.dataJs[indice].Children[index].Children = array  : ''
              // console.log(this.dataJs, 'this.dataJs')
            })
        })
    },
    returnPage(estado) {   
      if( this.stateContract === 'prueba') {
        this.$store.dispatch('setContractStatus', estado)
        // this.$localStorage.set('state', JSON.stringify(estado))
        this.$router.push({ name: 'historyContract' }) 
      }    
      else {
          this.$router.push({ name: 'contract' })  
      }
    },
    /** Envia a la vista del historial de contrato donde se mostraran todas sus adendas 
    * @param {String} stateHistory - Envia el registro del historial
    * @param {Object} item - envia la lista del historial de todas las adendas de ese contrato
    */
    changeContract(stateHistory, item) {
      //stateHistory es el objeto contractHistory en donde se guarda el historial del contrato
      this.$localStorage.set('stateH', JSON.stringify(stateHistory)) // se guarda la palabra historial 
      this.$localStorage.set('contratoHistory', JSON.stringify(item)) // aqui el objeto contractHistory

      this.$router.push({ name: 'historyContract' })
    },

    tableRowClassName2 ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bg-gray';
      }
    },

    tableRowClassNameMaterialsContract ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bgGrayAndTextOrange';
      }
      else if( rowIndex === 1) {
        return 'bg-white-border';
      }
    },
    
    tableRowClassNameSpace ({row, rowIndex}) {
      if (rowIndex === 1 || rowIndex===3) {
        return 'bg-pink-light';
      }
    return '';
    },
    /** Entrar a la edicion del contrato o adenda, o agregar una adenda
    * @param {String} item - Estado del contrato si es adenda, pendiente o adenda pendiente
    * @param {Object} contrato - Objecto que trae todos los datos del contrato para realizar su edicion
    */
    enterAddendum(item, contrato) {
      console.log(item, 'item')
      console.log(contrato, 'contrato')
      this.$store.dispatch('setItemInConfirmedContract', item)
      this.$store.dispatch('setContractInConfirmedContract', contrato)
      
      // se envia el estado de la adenda y un objeto del contrato
      // this.$localStorage.set('stateAdendum', JSON.stringify(item))
      // this.$localStorage.set('contrato', JSON.stringify(contrato))
      this.$router.push({ name: 'newContract' })
    },
    classCellTable(index, all){
      if(!(0 == (all.length -1))){
        if(index == 0 && index < all.length){
          return 'bottomStyleCell'
        } else if(index < all.length && index !== (all.length-1)){
          return 'bottomTopStyleCell'
        } else {
          return 'topStyleCell'
        }
      }
    },
  },
  mounted() {
    this.americaTv = this.prueba.filter(e => e.type == 'América TV')
    this.americaNext = this.prueba.filter(e => e.type == 'América Next')

    let counter = this.prueba.filter(e => e.__level == 0).length
    for(let i = 0; i < counter; i++) {
      this.foldList.push(`x_${i}`)
    }
  }
}
</script>

<style>
  .el-table th.is-leaf {
    border-bottom: 1px solid rgb(155,151,150);
  }
  .bg-white-border {
    background-color: #FFF;
    border: 1px solid rgb(155,151,150);
  }
  .font-weight-min {
    font-weight: 500;
  }
  .box-gray {
    background-color: rgb(224,224,224);
    width: 52%;
    box-sizing: border-box;
    padding: 10px;
  }
  .text-ellipsis {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }
  .confirmedContract thead tr:first-child th {
    border-top: none !important;
  }
  .confirmedContract thead tr:first-child th:first-child {
    border-left: none !important;
  }
  .btnEditStyle {
    background-color: #18974E !important;
    color: #FFFF !important;
    letter-spacing: 1px;
    font-weight: 500;
    border: 1px solid #18974E !important;
  }
  .btnEditStyle:hover {
    background-color: #FFFF !important;
    color: #18974E !important;
  }
  .bgdContractPending {
    background-color: #828282 !important;
  }
  .styleTitleGeneral{
    font-size:20px; 
    font-weight:700; 
    background-color: #828282 !important; 
    color: #FFFF !important;
  }
  .f-size-13{
    font-size: 13px;
    line-height: 1.3;
  }
    .el-table .cell {
    padding-left: 0 !important;
    padding-right: 0 !important;
  }
  .el-table th > .cell {
    padding-left: 10px!important;
    padding-right: 10px!important;
  }
  .bottomStyleCell{
    padding-bottom: 12px;
    border-bottom: 1px solid grey;
  }
  .bottomTopStyleCell{
    padding-top: 12px;
    padding-bottom: 12px;
    border-bottom: 1px solid grey;
  }
  .topStyleCell{
    padding-top: 12px;
  }
</style>
